﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

using System.Data.SqlClient;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Razor_CheckBoxList.Pages
{
    public class IndexModel : PageModel
    {
        public List<SelectListItem> Fruits { get; set; }

        public void OnGet()
        {
            //Populate Model from Database.
            this.Fruits = PopulateFruits();
        }

        public void OnPostSubmit(string[] fruit)
        {
            //Populate Model from Database.
            this.Fruits = PopulateFruits();

            string message = "Selected Items:\\n";
            foreach (SelectListItem item in this.Fruits)
            {
                if (fruit.Contains(item.Value))
                {
                    //Fetch the TEXT value.
                    item.Selected = true;
                    message += string.Format("{0}\\n", item.Text);
                }
            }

            //Set the value in ViewData.
            ViewData["Message"] = message;
        }

        private static List<SelectListItem> PopulateFruits()
        {
            string constr = @"Data Source=.\SQL2019;Initial Catalog=AjaxSamples;Integrated Security=true";
            List<SelectListItem> items = new List<SelectListItem>();
            using (SqlConnection con = new SqlConnection(constr))
            {
                string query = " SELECT FruitName, FruitId FROM Fruits";
                using (SqlCommand cmd = new SqlCommand(query))
                {
                    cmd.Connection = con;
                    con.Open();
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        while (sdr.Read())
                        {
                            items.Add(new SelectListItem
                            {
                                Text = sdr["FruitName"].ToString(),
                                Value = sdr["FruitId"].ToString()
                            });
                        }
                    }
                    con.Close();
                }
            }
            return items;
        }
    }
}